#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_GiftGuideCFG.h"
std::auto_ptr<M_GiftGuideCFG> M_GiftGuideCFG::msSingleton(nullptr);

int M_GiftGuideCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_GiftGuideCFGData* M_GiftGuideCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_GiftGuideCFGData>& M_GiftGuideCFG::GetMapData()
{
	return mMapData;
}

void M_GiftGuideCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_GiftGuideCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_GiftGuideCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mNeedLevel = element->IntAttribute("NeedLevel");
		data.mType = element->IntAttribute("Type");
		data.mRechangeID = element->IntAttribute("RechangeID");
		data.mContinueTime = element->IntAttribute("ContinueTime");
		{
			const char* AwardItem = element->Attribute("AwardItem");
			std::vector<std::string> vecAwardItem;
			boost::split(vecAwardItem, AwardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItem[i].c_str(), &temp))
				{
					data.mAwardItem.push_back(temp);
				}
			}
		}
		data.mParam = element->IntAttribute("Param");
		data.mTitleImage = element->Attribute("TitleImage");
		data.mLeftImage = element->Attribute("LeftImage");
		data.mRMBImage = element->Attribute("RMBImage");
		{
			const char* GemPrice = element->Attribute("GemPrice");
			std::vector<std::string> vecGemPrice;
			boost::split(vecGemPrice, GemPrice, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGemPrice.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGemPrice[i].c_str(), &temp))
				{
					data.mGemPrice.push_back(temp);
				}
			}
		}
		data.mStartTime = element->Attribute("StartTime");
		data.mEndTime = element->Attribute("EndTime");
		data.mRefreshWeekDay = element->IntAttribute("RefreshWeekDay");
		data.mBuyCount = element->IntAttribute("BuyCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_GiftGuideCFG Loaded. Load Data:%u", mMapData.size());
}

void M_GiftGuideCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_GiftGuideCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_GiftGuideCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_GiftGuideCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "NeedLevel", data.mNeedLevel);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "RechangeID", data.mRechangeID);
		LuaCfgHelper::readInt(L, "ContinueTime", data.mContinueTime);
		LuaCfgHelper::readVectorInt(L, "AwardItem", data.mAwardItem);
		LuaCfgHelper::readInt(L, "Param", data.mParam);
		LuaCfgHelper::readString(L, "TitleImage", data.mTitleImage);
		LuaCfgHelper::readString(L, "LeftImage", data.mLeftImage);
		LuaCfgHelper::readString(L, "RMBImage", data.mRMBImage);
		LuaCfgHelper::readVectorInt(L, "GemPrice", data.mGemPrice);
		LuaCfgHelper::readString(L, "StartTime", data.mStartTime);
		LuaCfgHelper::readString(L, "EndTime", data.mEndTime);
		LuaCfgHelper::readInt(L, "RefreshWeekDay", data.mRefreshWeekDay);
		LuaCfgHelper::readInt(L, "BuyCount", data.mBuyCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_GiftGuideCFG Loaded. Load Data:%u", mMapData.size());
}

void M_GiftGuideCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_GiftGuideCFG* M_GiftGuideCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_GiftGuideCFG());
	}
	return msSingleton.get();
}

void M_GiftGuideCFG::Release()
{
	msSingleton.reset(nullptr);
}
